; Stickit-Created by graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html

;;;;
(define (script-fu-stickit image
                           drawable
                               )
							  

 (let* (
            (image-layer (car (gimp-image-get-active-layer image)))
			(width (car (gimp-image-width image)))
			(height (car (gimp-image-height image)))
            (mean-size (/ (+ width height) 2)) 
            (tape-layer 0)
			(tape-width 0)
			(tape-height 0)
			(offx 0)
			(offy 0)
			(offsetx (/ width 2))
			(offsety (-(/ height 2)))
			(top-right-layer 0)
			(top-left-layer 0)
			(bottem-right-layer 0)
			(bottem-left-layer 0)
			(bkg-layer 0)


  			
        )
    (gimp-context-push)
    (gimp-image-undo-group-start image)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
		


	(set! tape-width (/ mean-size 6.36))
	(set! tape-height (/ mean-size 30))

;;;;create the tape
    (set! tape-layer (car (gimp-layer-new image tape-width tape-height RGBA-IMAGE "Tape" 50 NORMAL-MODE)))	
	(gimp-image-add-layer image tape-layer -1)
	(gimp-drawable-fill tape-layer BACKGROUND-FILL)
	(plug-in-ripple RUN-NONINTERACTIVE image tape-layer (/ mean-size 43.75) (/ mean-size 76.56) 0 2 0 TRUE FALSE)
	
;;;;centre the tape-layer	
    (set! offx (/ (- width tape-width) 2))
    (set! offy (/ (- height tape-height) 2))    
    (gimp-layer-set-offsets tape-layer offx offy)	
	
;;;;create the top-right-layer
	(set! top-right-layer (car (gimp-layer-copy tape-layer TRUE)))
    (gimp-image-add-layer image top-right-layer -1)
    (gimp-drawable-set-name top-right-layer "Top-Right-Layer")
	(gimp-layer-translate top-right-layer (/ width 2) (-(- (/ height 2) (/ tape-height 2))))
	(gimp-drawable-transform-rotate top-right-layer 45 FALSE width (/ tape-height 2) 0 2 FALSE 1 0)
	
;;;;create the top-left-layer 	
	(set! top-left-layer (car (gimp-layer-copy tape-layer TRUE)))
    (gimp-image-add-layer image top-left-layer -1)
    (gimp-drawable-set-name top-left-layer "Top-Left-Layer")
	(gimp-layer-translate top-left-layer (-(/ width 2)) (-(- (/ height 2) (/ tape-height 2))))
	(gimp-drawable-transform-rotate top-left-layer 45 FALSE 0 (/ tape-height 2) 1 2 FALSE 1 0)
	
;;;;create the bottem-right-layer
	(set! bottem-right-layer (car (gimp-layer-copy tape-layer TRUE)))
    (gimp-image-add-layer image bottem-right-layer -1)
    (gimp-drawable-set-name bottem-right-layer "Bottem-Right-Layer")
	(gimp-layer-translate bottem-right-layer (/ width 2) (- (/ height 2) (/ tape-height 2)))
	(gimp-drawable-transform-rotate bottem-right-layer 45 FALSE width (- height (/ tape-height 2)) 1 2 FALSE 1 0)
		
;;;;create the bottem-left-layer
	(set! bottem-left-layer (car (gimp-layer-copy tape-layer TRUE)))
    (gimp-image-add-layer image bottem-left-layer -1)
    (gimp-drawable-set-name bottem-left-layer "Bottem-left-Layer")
	(gimp-layer-translate bottem-left-layer (-(/ width 2)) (- (/ height 2) (/ tape-height 2)))
	(gimp-drawable-transform-rotate bottem-left-layer 45 FALSE 0 (- height (/ tape-height 2)) 0 2 FALSE 1 0)

;;;;tidy the layers		
    (gimp-image-remove-layer image tape-layer)
	(gimp-image-merge-visible-layers image  EXPAND-AS-NECESSARY)
    (gimp-image-resize-to-layers image)
	
;;;;create the background layer    
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
	(gimp-drawable-fill bkg-layer FOREGROUND-FILL)
	
	
	
	
	
	
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
	(gimp-context-pop)
    



 )
) 



(script-fu-register "script-fu-stickit"        		    
                    "Stickit"
                     "Instructions"
                    "Graechan"
                    "Graechan"
                    "January 2012"
                    "RGB*"
                    SF-IMAGE      "image"      0
                    SF-DRAWABLE   "drawable"   0
                    
)

(script-fu-menu-register "script-fu-stickit" "<Image>/Script-Fu/Misc/")


