; Symbol Display rel 0.04
; Created by Graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
; Rel 0.02 - Added a default font to prevent script running without a font being selected
; Rel 0.03 - Changed Menu to allow for optional selection of 'lower case' 'numerals' and 'control characters'
; Rel 0.04 - Add control of the original letter size and minor bugfixes,forces selection of capitols if no option chosen
;
(define capitols (quote (A B C D E F G H I J K L M N O P Q R S T U V W X Y Z)))
(define lcase (quote (a b c d e f g h i j k l m n o p q r s t u v w x y z)))
(define nums (quote (1 2 3 4 5 6 7 8 9 0)))
(define chars (quote ("~" "!" "@" "#" "$" "%" "^" "&" "*" "(" ")" "_" "+" "-" "=" ";" ":" "'" "," "<" "." ">" "/" "?" "{" "}" "[" "]" "|")))
;
(define (script-fu-symbol-display 
                               img-width
							   active
                               font-in-out
							   text-size
							   font-size
							   caps
							   lclets
							   numeric
							   chatr)							  

 (let* (
            (width 50)
			(height 50)
			(image (car (gimp-image-new width height RGB)))
			(font-in (if (= active TRUE) (car (gimp-context-get-font)) font-in-out))
		    (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
			(layer 0)
			(sym-list 0)
			(num-list nums)
			(char-list chars)
			(text 0)
			(text-layer 0)
			(bats-layer 0)
			(ver 2.8)
			(offx 0) 
			(offy 0)
			(text-width 0)
			(text-height 0)
			(bats-width 0)
			(bats-height 0)
			(header-layer 0)
			(size font-size)
			(aspect 0)
			(hwidth (car (gimp-text-get-extents-fontname font size PIXELS "Sans Bold")))
			(hheight (cadr (gimp-text-get-extents-fontname font size PIXELS "Sans Bold")))
        )
	(cond ((not (defined? 'gimp-image-get-item-position)) (set! ver 2.6))) ;define the gimp version
	
	(gimp-context-push)
	(gimp-context-set-paint-method "gimp-paintbrush")
	(if (= ver 2.8) (gimp-context-set-dynamics "Dynamics Off"))
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
	(cond ((= caps TRUE) (set! caps TRUE))
	      ((= lclets TRUE) (set! lclets TRUE))
		  ((= numeric TRUE) (set! numeric TRUE))
		  ((= chatr TRUE) (set! chatr TRUE))
		  (else  (set! caps TRUE)))

;;;;begin the script
    (if (= caps TRUE) (begin
	(set! sym-list capitols)	
;;;;caps---------------------------------------------------------------------------------------------------------------------	
	(while (not (null? sym-list))
	(cond ((> (+ offx text-width bats-width) img-width)
    (set! offy (car (gimp-image-height image)))
	(set! offx 0))
    ) ;endcond	
	(set! text (car sym-list))
	(set! text-layer (car (gimp-text-fontname image -1 0 0 (symbol->string text) 0 TRUE text-size PIXELS "Sans Bold")))
	(gimp-layer-set-offsets text-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width text-layer)) offx))
    (set! text-width (car (gimp-drawable-width text-layer)))
    (set! text-height (car (gimp-drawable-height text-layer)))
	(set! bats-layer (car (gimp-text-fontname image -1 0 0 (symbol->string text) 0 TRUE font-size PIXELS font)))
	(gimp-layer-set-offsets bats-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width bats-layer)) offx))
	(set! bats-width (car (gimp-drawable-width bats-layer)))
    (set! bats-height (car (gimp-drawable-height bats-layer)))
	(set! layer (car (gimp-image-merge-down image bats-layer EXPAND-AS-NECESSARY)))
	(set! sym-list (cdr sym-list))
	) ;endwhile
	)) ;endif

;;;;lower case--------------------------------------------------------------------------------------------------------------------	
	(if (= lclets TRUE) (begin
	(set! sym-list lcase)
	
	(while (not (null? sym-list))
	(cond ((> (+ offx text-width bats-width) img-width)
    (set! offy (car (gimp-image-height image)))
	(set! offx 0))
    ) ;endcond	
	(set! text (car sym-list))
	(set! text-layer (car (gimp-text-fontname image -1 0 0 (symbol->string text) 0 TRUE text-size PIXELS "Sans Bold")))
	(gimp-layer-set-offsets text-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width text-layer)) offx))
    (set! text-width (car (gimp-drawable-width text-layer)))
    (set! text-height (car (gimp-drawable-height text-layer)))
	(set! bats-layer (car (gimp-text-fontname image -1 0 0 (symbol->string text) 0 TRUE font-size PIXELS font)))
	(gimp-layer-set-offsets bats-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width bats-layer)) offx))
	(set! bats-width (car (gimp-drawable-width bats-layer)))
    (set! bats-height (car (gimp-drawable-height bats-layer)))
	(set! layer (car (gimp-image-merge-down image bats-layer EXPAND-AS-NECESSARY)))
	(set! sym-list (cdr sym-list))
	) ;endwhile
	)) ;endif

;;;;numerals------------------------------------------------------------------------------------------------------------------
     
	(if (= numeric TRUE) (begin
	(set! sym-list nums)
	
	(while (not (null? sym-list))
	(cond ((> (+ offx text-width bats-width) img-width)
    (set! offy (car (gimp-image-height image)))
	(set! offx 0))
    ) ;endcond	
	(set! text (car sym-list))
	(set! text-layer (car (gimp-text-fontname image -1 0 0 (number->string text) 0 TRUE text-size PIXELS "Sans Bold")))
	(gimp-layer-set-offsets text-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width text-layer)) offx))
    (set! text-width (car (gimp-drawable-width text-layer)))
    (set! text-height (car (gimp-drawable-height text-layer)))
	(set! bats-layer (car (gimp-text-fontname image -1 0 0 (number->string text) 0 TRUE font-size PIXELS font)))
	(gimp-layer-set-offsets bats-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width bats-layer)) offx))
	(set! bats-width (car (gimp-drawable-width bats-layer)))
    (set! bats-height (car (gimp-drawable-height bats-layer)))
	(set! layer (car (gimp-image-merge-down image bats-layer EXPAND-AS-NECESSARY)))
	(set! sym-list (cdr sym-list))
	) ;endwhile
	)) ;endif
	
;;;;control characters------------------------------------------------------------------------------------------------------
    (if (= chatr TRUE) (begin
	(set! sym-list chars)
	
	(while (not (null? sym-list))
	(cond ((> (+ offx text-width bats-width) img-width)
    (set! offy (car (gimp-image-height image)))
	(set! offx 0))
    ) ;endcond	
	(set! text (car sym-list))
	(set! text-layer (car (gimp-text-fontname image -1 0 0 text 0 TRUE text-size PIXELS "Sans Bold")))
	(gimp-layer-set-offsets text-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width text-layer)) offx))
    (set! text-width (car (gimp-drawable-width text-layer)))
    (set! text-height (car (gimp-drawable-height text-layer)))
	(set! bats-layer (car (gimp-text-fontname image -1 0 0 text 0 TRUE font-size PIXELS font)))
	(gimp-layer-set-offsets bats-layer offx offy)
	(gimp-image-resize-to-layers image)
	(set! offx (+ (car (gimp-drawable-width bats-layer)) offx))
	(set! bats-width (car (gimp-drawable-width bats-layer)))
    (set! bats-height (car (gimp-drawable-height bats-layer)))
	(set! layer (car (gimp-image-merge-down image bats-layer EXPAND-AS-NECESSARY)))
	(set! sym-list (cdr sym-list))
	) ;endwhile
	)) ;endif	

	
	
	(set! bats-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
	(script-fu-addborder image bats-layer 2 2 '(0 0 0) 25)
	(gimp-displays-flush)
	(set! bats-layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))
	
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
	(cond ((> hwidth width)
	(while (> hwidth width)
	(set! size (- size 1))
	(set! hwidth (car (gimp-text-get-extents-fontname font size PIXELS "Sans Bold")))
	) ;endwhile
	)) ;endcond
	
	(cond ((< hwidth width)
	(while (< hwidth width)
	(set! size (+ size 1))
	(set! hwidth (car (gimp-text-get-extents-fontname font size PIXELS "Sans Bold")))
	) ;endwhile
	(set! size (- size 1))
	)) ;endcond	
	
	(set! header-layer (car (gimp-text-fontname image -1 0 0 font 0 TRUE size PIXELS "Sans Bold")))
	(set! offy (car (gimp-drawable-height header-layer)))
	(gimp-layer-set-offsets header-layer 0 (- 0 offy))
	(gimp-image-resize-to-layers image)
	
	(script-fu-addborder image header-layer 2 2 '(0 0 0) 25)
	(gimp-displays-flush)
	(set! layer (car (gimp-image-merge-visible-layers image EXPAND-AS-NECESSARY)))

;;;;scale the image
    (set! aspect (/ img-width (car (gimp-image-width image)))) 
    (gimp-image-scale image img-width (* (car (gimp-image-height image)) aspect))	
	
;;;;finish the script	
    (cond ((= ver 2.8) (gimp-item-set-name layer font))
	(else (gimp-drawable-set-name layer font))
    ) ;endcond
	
    (gimp-display-new image)
	(gimp-displays-flush)
	(gimp-context-pop)

 )
)

(script-fu-register "script-fu-symbol-display"        		    
  "Symbol Display"
  "Displays symbol fonts such as Dingbats and their corresponding key"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "2013"
  ""
  SF-ADJUSTMENT "Image width (pixels)" '(750 1 10000 1 10 0 1)
  SF-TOGGLE     "Display the Active Font"   FALSE
  SF-FONT       "Symbol Font [enter your Dingbat]"               "Sans"
  SF-ADJUSTMENT "Letter Size (pixels)" '(20 6 500 1 1 0 1)
  SF-ADJUSTMENT "Symbol Font Size (pixels)" '(100 6 1000 1 1 0 1)
  SF-TOGGLE     "Apply to Upper Case"   TRUE
  SF-TOGGLE     "Apply to Lower Case"   FALSE
  SF-TOGGLE     "Apply to Numerals"     FALSE
  SF-TOGGLE     "Apply to Characters"   FALSE
)

(script-fu-menu-register "script-fu-symbol-display" "<Fonts>/")


